Index: src/uk/me/parabola/mkgmap/reader/osm/MultiPolygonRelation.java
===================================================================
--- src/uk/me/parabola/mkgmap/reader/osm/MultiPolygonRelation.java	(revision 4689)
+++ src/uk/me/parabola/mkgmap/reader/osm/MultiPolygonRelation.java	(working copy)
@@ -1137,20 +1137,9 @@
 		// copy all polygons created by the multipolygon algorithm to the global way map
 		tileWayMap.putAll(mpPolygons);
 		
-		if (largestOuterPolygon != null) {
-			// check if the mp contains a node with role "label" 
-			for (Map.Entry<String, Element> entry : getElements()) {
-				if (entry.getValue() instanceof Node && "label".equals(entry.getKey())) {
-					// yes => use the label node as reference point
-					cOfG = ((Node) entry.getValue()).getLocation();
-					break;
-				}
-			}
-			
-			if (cOfG == null) {
-				// use the center of the largest polygon as reference point
-				cOfG = largestOuterPolygon.getCofG();
-			}
+		if ((largestOuterPolygon != null) && (cOfG == null)) {
+			// use the centre of the largest polygon as reference point
+			cOfG = largestOuterPolygon.getCofG();
 		}
 	}
 	
Index: src/uk/me/parabola/mkgmap/reader/osm/POIGeneratorHook.java
===================================================================
--- src/uk/me/parabola/mkgmap/reader/osm/POIGeneratorHook.java	(revision 4689)
+++ src/uk/me/parabola/mkgmap/reader/osm/POIGeneratorHook.java	(working copy)
@@ -447,20 +447,20 @@
 					String role = pair.getKey();
 					Element el = pair.getValue();
 					if (el instanceof Node){
-						if ("admin_centre".equals(role)){
+						if ("admin_centre".equals(role)) {
 							if ("boundary".equals(r.getTag("type")) && "administrative".equals(r.getTag("boundary"))){
 								// boundary relations may have a node with role admin_centre, if yes, use the 
 								// location of it
 								String pName = nameFinder.getName(el);
-								if (relName.equals(pName)){
+								if (relName.equals(pName) || pName == null) {
 									adminCentre = (Node) el;
 									if (log.isDebugEnabled())
 										log.debug("using admin_centre node as location for POI for rel",r.getId(),relName,"at",((Node) el).getLocation().toDegreeString());
 								}
 							}
-						} else if ("label".equals(role)){
+						} else if ("label".equals(role)) {
 							String label = nameFinder.getName(el);
-							if (relName.equals(label)){
+							if (relName.equals(label) || label == null) {
 								labelPOI = (Node) el;
 								log.debug("using label node as location for POI for rel",r.getId(),relName,"at",((Node) el).getLocation().toDegreeString());
 								break;
@@ -471,15 +471,13 @@
 					}
 				}
 			}
-			Coord point = null;
-			if (adminCentre == null && labelPOI == null)
+			Coord point;
+			if (labelPOI != null)
+				point = labelPOI.getLocation();
+			else if(adminCentre != null)
+				point = adminCentre.getLocation();
+			else
 				point = ((MultiPolygonRelation)r).getCofG();
-			else {
-				if (labelPOI != null)
-					point = labelPOI.getLocation();
-				else 
-					point = adminCentre.getLocation();
-			}
 
 			if (point != null) {
 				Node poi = addPOI(r, point, TKM_AREA2POI, 0);
